diff --git a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
index fd1981910..6666bf4ef 100644
--- a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
+++ b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
@@ -2,10 +2,10 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.client.gui.options.GuiOptionsButton;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.inventory.ContainerPlayerCreative;
+import net.minecraft.core.player.inventory.menu.CreativeInventoryMenu;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.EntityRenderDispatcher;
@@ -14,6 +14,7 @@ import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.gui.GuiTextField.ITextChangeListener;
+import org.lwjgl.opengl.GL12;
 
 public class GuiInventoryCreative extends GuiInventory implements ITextChangeListener
 {
@@ -21,14 +22,14 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	protected GuiButton nextPageButton;
 	protected GuiOptionsButton clearSearchButton;
 	protected GuiTextField searchField;
-	protected ContainerPlayerCreative container;
+	protected CreativeInventoryMenu container;
 	protected String pageString = "1/1";
 	
-	public GuiInventoryCreative(EntityPlayer entityplayer)
+	public GuiInventoryCreative(Player entityplayer)
 	{
 		super(entityplayer);
 		xSize = 298;
-		container = (ContainerPlayerCreative)entityplayer.inventorySlots;
+		container = (CreativeInventoryMenu)entityplayer.inventorySlots;
 		armourValuesFloat = 186;
 		armourButtonFloatX = 81;
 		overlayButtonsLayout.setOffset(-(xSize / 2), -(ySize / 2) - 10);
@@ -113,8 +114,8 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
     	{
 			if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT))
 			{
-				for(int i = 0; i < container.playerInv.getSizeInventory() + container.craftMatrix.getSizeInventory() + container.craftResult.getSizeInventory(); i++) {
-					mc.playerController.handleInventoryMouseClick(container.windowId, InventoryAction.CREATIVE_DELETE, new int[]{i}, mc.thePlayer);
+				for(int i = 0; i < container.inventory.getContainerSize() + container.craftSlots.getContainerSize() + container.resultSlots.getContainerSize(); i++) {
+					mc.playerController.handleInventoryMouseClick(container.containerId, InventoryAction.CREATIVE_DELETE, new int[]{i}, mc.thePlayer);
 				}
 			}
 			else
@@ -166,10 +167,9 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
 		scroll(Mouse.getDWheel());
-		
-        int i = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/creative.png");
+
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(i);
+		mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/creative.png").bind();
         int x = (width - xSize) / 2;
         int y = (height - ySize) / 2;
         lastPageButton.xPosition = x + 182;
@@ -181,15 +181,15 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
         searchField.xPosition = x + 183;
         searchField.yPosition = y + 7;
         drawTexturedModalRect((double)x, (double)y, 0, 0, xSize, ySize, xSize / 2, ySize / 2);
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
-        GL11.glEnable(2903 /*GL_COLOR_MATERIAL*/);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
         GL11.glPushMatrix();
         GL11.glTranslatef(x + 51, y + 75, 50F);
         float f1 = 30F;
         GL11.glScalef(-f1, f1, f1);
         GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
-        float f2 = mc.thePlayer.renderYawOffset;
+        float f2 = mc.thePlayer.yBodyRot;
         float f3 = mc.thePlayer.yRot;
         float f4 = mc.thePlayer.xRot;
         float f5 = (float)(x + 51) - xSize_lo;
@@ -198,7 +198,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
         Lighting.enableLight();
         GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
         GL11.glRotatef(-(float)Math.atan(f6 / 40F) * 20F, 1.0F, 0.0F, 0.0F);
-        mc.thePlayer.renderYawOffset = (float)Math.atan(f5 / 40F) * 20F;
+        mc.thePlayer.yBodyRot = (float)Math.atan(f5 / 40F) * 20F;
         mc.thePlayer.yRot = (float)Math.atan(f5 / 40F) * 40F;
         mc.thePlayer.xRot = -(float)Math.atan(f6 / 40F) * 20F;
         mc.thePlayer.entityBrightness = 1.0F;
@@ -206,12 +206,12 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
         EntityRenderDispatcher.instance.viewLerpYaw = 180F;
         EntityRenderDispatcher.instance.renderEntityWithPosYaw(Tessellator.instance, mc.thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
         mc.thePlayer.entityBrightness = 0.0F;
-        mc.thePlayer.renderYawOffset = f2;
+        mc.thePlayer.yBodyRot = f2;
         mc.thePlayer.yRot = f3;
         mc.thePlayer.xRot = f4;
         GL11.glPopMatrix();
         Lighting.disable();
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         searchField.drawTextBox();
     }
 
@@ -222,10 +222,10 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	}
 	@Override
 	public void guiSpecificControllerInput(ControllerInput controller){
-		if(controller.buttonL.pressedThisFrame()) {
+		if(controller.buttonLeftShoulder.pressedThisFrame()) {
 			this.scroll(1);
 		}
-		if(controller.buttonR.pressedThisFrame()) {
+		if(controller.buttonRightShoulder.pressedThisFrame()) {
 			this.scroll(-1);
 		}
 		super.guiSpecificControllerInput(controller);
diff --git a/src/main/java/net/minecraft/client/gui/GuiMainMenu.java b/src/main/java/net/minecraft/client/gui/GuiMainMenu.java
index 5039b5b2d..359f01da7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiMainMenu.java
+++ b/src/main/java/net/minecraft/client/gui/GuiMainMenu.java
@@ -16,7 +16,7 @@ import java.util.Random;
 import javax.imageio.ImageIO;
 
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import org.lwjgl.input.Keyboard;
@@ -28,6 +28,7 @@ import net.minecraft.client.gui.options.GuiOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
@@ -36,8 +37,8 @@ public class GuiMainMenu extends GuiScreen
 {
 
     private static final Block[] BLOCKS_TO_DRAW = {
-    		Block.stone, Block.dirt, Block.planksOak, Block.cobbleStone, Block.cobbleStoneMossy, Block.basalt, Block.limestone,
-    		Block.granite, Block.brickClay, Block.ice, Block.wool, Block.blockSnow, Block.obsidian, Block.netherrack
+    		Blocks.STONE, Blocks.DIRT, Blocks.PLANKS_OAK, Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY, Blocks.BASALT, Blocks.LIMESTONE,
+    		Blocks.GRANITE, Blocks.BRICK_CLAY, Blocks.ICE, Blocks.WOOL, Blocks.BLOCK_SNOW, Blocks.OBSIDIAN, Blocks.NETHERRACK
     };
     private static String[] logoBlockLayers = null;
     
@@ -65,7 +66,7 @@ public class GuiMainMenu extends GuiScreen
 
 		InputStream stream = null;
 		try {
-			stream = GuiMainMenu.class.getResourceAsStream("/title/splashes.txt");
+			stream = GuiMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/splashes.txt");
 
 			List<String> allSplashes = new ArrayList<>();
 			BufferedReader br = new BufferedReader(new InputStreamReader(stream, StandardCharsets.UTF_8));
@@ -165,11 +166,13 @@ public class GuiMainMenu extends GuiScreen
             controlList.add(new GuiButton(4, width / 2 + 2, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.quit_game")));
         }
         int d = 1; // Move away from the edge of the screen to prevent unintentional activation because the cursor defaults to 0, 0
-        controlList.add(new GuiClickableLabel(5, d, height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0x5AA938));
-        controlList.add(new GuiClickableLabel(6, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0x5865F2));
-        controlList.add(new GuiClickableLabel(7, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFF0000));
-        controlList.add(new GuiTexturedButton(8, "/assets/minecraft/textures/gui/gui.png", width / 2 + 104, i + 72 + 12, 0, 86, 20, 20));
-        GuiButton debugButton = new GuiButton(9, width - 8, height - 8, 8, 8, "");
+        controlList.add(new GuiClickableLabel(5, d, height - 48 - d, i18n.translateKey("gui.main_menu.button.credits"), 0x9F9F9F));
+        controlList.add(new GuiClickableLabel(6, d, height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0x5AA938));
+        controlList.add(new GuiClickableLabel(7, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0x5865F2));
+        controlList.add(new GuiClickableLabel(8, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFF0000));
+        controlList.add(new GuiButton(9, width / 2 + 104, i + 72 + 12, 20, 20, "")
+            .setTextures("minecraft:gui/misc/button_language", "minecraft:gui/misc/button_language_highlighted", "minecraft:gui/misc/button_language"));
+        GuiButton debugButton = new GuiButton(10, width - 8, height - 8, 8, 8, "");
         debugButton.visible = false;
         controlList.add(debugButton);
         if(mc.session == null)
@@ -206,17 +209,21 @@ public class GuiMainMenu extends GuiScreen
         {
             mc.shutdown();
         }
-        if(button.id == 8)
+        if(button.id == 5)
+        {
+            mc.displayGuiScreen(new GuiCredits(this));
+        }
+        if(button.id == 9)
         {
             mc.displayGuiScreen(new GuiOptions(this, OptionsPages.LANGUAGE));
         }
-        if(button.id == 9){
+        if(button.id == 10){
             mc.displayGuiScreen(new GuiOptions(this, OptionsPages.DEBUG));
         }
         Desktop desktop = Desktop.isDesktopSupported() ? Desktop.getDesktop() : null;
         if (desktop != null && desktop.isSupported(Desktop.Action.BROWSE))
         {
-            if (button.id == 5) // Website
+            if (button.id == 6) // Website
             {
                 try
                 {
@@ -226,7 +233,7 @@ public class GuiMainMenu extends GuiScreen
                     e.printStackTrace();
                 }
             }
-            if (button.id == 6) // Discord
+            if (button.id == 7) // Discord
             {
                 try
                 {
@@ -236,7 +243,7 @@ public class GuiMainMenu extends GuiScreen
                     e.printStackTrace();
                 }
             }
-            if (button.id == 7) // YouTube
+            if (button.id == 8) // YouTube
             {
                 try
                 {
@@ -316,10 +323,9 @@ public class GuiMainMenu extends GuiScreen
         byte byte0 = 30;
         if (!mc.gameSettings.alphaMenu.value)
         {
-            GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture("/title/mclogo.png"));
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            drawTexturedModalRect(k + 0, byte0 + 0, 0, 0, 155, 64);
-            drawTexturedModalRect(k + 155, byte0 + 0, 0, 64, 155, 64);
+            drawTexturedModalRect(k + 0, byte0 + 0, 0, 0, 274, 50, 1d/274, 1d/50);
         }
         else
         {
@@ -328,7 +334,7 @@ public class GuiMainMenu extends GuiScreen
         GL11.glPushMatrix();
         GL11.glTranslatef(width / 2 + 140, 80F, 0.0F);
         GL11.glRotatef(-20F, 0.0F, 0.0F, 1.0F);
-        float f1 = 1.8F - MathHelper.abs(MathHelper.sin(((float)(System.currentTimeMillis() % 1000L) / 1000F) * 3.141593F * 2.0F) * 0.1F);
+        float f1 = 1.8F - MathHelper.abs(MathHelper.sin(((float)(System.currentTimeMillis() % 1000L) / 1000F) * MathHelper.PI * 2.0F) * 0.1F);
         f1 = (f1 * 100F) / (float)(fontRenderer.getStringWidth(splashText) + 32);
         GL11.glScalef(f1, f1, f1);
         drawStringCentered(fontRenderer, splashText, 0, -8, 0xffff00);
@@ -407,9 +413,9 @@ public class GuiMainMenu extends GuiScreen
             GL11.glRotatef(15.0F, 1.0F, 0.0F, 0.0F);
             GL11.glScalef(0.89F, 1.0F, 0.4F);
             GL11.glTranslatef((float)(-logoBlockLayers[0].length()) * 0.5F, (float)(-logoBlockLayers.length) * 0.5F, 0.0F);
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             if(var4 == 0) {
-                GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/title/black.png"));
+                this.mc.renderEngine.loadTexture("/title/black.png").bind();
             }
 
             RenderBlocks var5 = new RenderBlocks();
@@ -456,7 +462,7 @@ public class GuiMainMenu extends GuiScreen
     
     public static void loadLogo() {
     	try {
-    		InputStream inputStream = GuiMainMenu.class.getResourceAsStream("/title/retrologo.png");
+    		InputStream inputStream = GuiMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/retrologo.png");
     		BufferedImage image = ImageIO.read(inputStream);
     		inputStream.close();
     		
diff --git a/src/main/java/net/minecraft/client/gui/GuiMissingMinecraft.java b/src/main/java/net/minecraft/client/gui/GuiMissingMinecraft.java
index 5b2ec3577..8d649f6ea 100644
--- a/src/main/java/net/minecraft/client/gui/GuiMissingMinecraft.java
+++ b/src/main/java/net/minecraft/client/gui/GuiMissingMinecraft.java
@@ -74,11 +74,11 @@ public class GuiMissingMinecraft extends GuiScreen{
 
     public void drawBackground(float partialTick)
     {
-        GL11.glDisable(2896 /*GL_LIGHTING*/);
-        GL11.glDisable(2912 /*GL_FOG*/);
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_FOG);
 
         Tessellator tessellator = Tessellator.instance;
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture("/assets/minecraft/textures/block/netherrack_mossy.png"));
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/block/netherrack_mossy.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GL11.glEnable(GL11.GL_BLEND);
 
@@ -92,7 +92,7 @@ public class GuiMissingMinecraft extends GuiScreen{
         tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0);
         tessellator.draw();
 
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture("/assets/minecraft/textures/block/dirt.png"));
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/block/dirt.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0f);
 
         // Then Draw dirt texture
diff --git a/src/main/java/net/minecraft/client/gui/GuiOutOfMemory.java b/src/main/java/net/minecraft/client/gui/GuiOutOfMemory.java
index 7269e00bc..8ceb51df8 100644
--- a/src/main/java/net/minecraft/client/gui/GuiOutOfMemory.java
+++ b/src/main/java/net/minecraft/client/gui/GuiOutOfMemory.java
@@ -18,12 +18,12 @@ public class GuiOutOfMemory extends GuiScreen
         I18n i18n = I18n.getInstance();
         drawDefaultBackground();
         drawStringCentered(fontRenderer, i18n.translateKey("gui.out_of_memory.label.title"), width / 2, (height / 4 - 60) + 20, 0xFFFFFF);
-        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xA0A0A0);
-        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xA0A0A0);
-        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xA0A0A0);
-        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xA0A0A0);
-        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.body.5"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xA0A0A0);
-        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.body.6"), width / 2 - 140, (height / 4 - 60) + 60 + 63, 0xA0A0A0);
+        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xA0A0A0);
+        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xA0A0A0);
+        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xA0A0A0);
+        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xA0A0A0);
+        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.5"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xA0A0A0);
+        drawString(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.6"), width / 2 - 140, (height / 4 - 60) + 60 + 63, 0xA0A0A0);
         super.drawScreen(mouseX, mouseY, partialTick);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java b/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
index 5e537ec2f..11cae75ca 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
+++ b/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -17,12 +17,12 @@ import static org.lwjgl.opengl.GL11.GL_BLEND;
 public class GuiPaintingPicker
     extends GuiScreen
 {
-    private final EntityPlayer player;
+    private final Player player;
     private final List<ArtEntry> artEntries = new ArrayList<>();
     private ArtType centerArt = ArtType.Kebab;
     private int tallestSize = 0;
 
-    public GuiPaintingPicker(EntityPlayer player)
+    public GuiPaintingPicker(Player player)
     {
         this.player = player;
         for (ArtType art : ArtType.values){
@@ -162,7 +162,7 @@ public class GuiPaintingPicker
 
     public void drawTexturedIconPainting(int x, int y, int width, int height, IconCoordinate coordinate, float alpha)
     {
-        coordinate.parentAtlas.bindTexture();
+        coordinate.parentAtlas.bind();
         Tessellator tessellator = Tessellator.instance;
         GL11.glColor4f(1f, 1f, 1f, alpha);
         tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
index be7fa667d..b79ddf22d 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
+++ b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextureButton;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.season.Season;
@@ -27,7 +27,7 @@ public class GuiPhotoMode extends GuiScreen
     private GuiSlider sliderTimeOfDay;
     private GuiButton buttonSeason;
     private GuiButton buttonTakeScreenshot;
-    private GuiListenerTextureButton buttonOpenScreenshotFolder;
+    private GuiListenerButton buttonOpenScreenshotFolder;
     private GuiButton buttonExit;
     private GuiSlider sliderFog;
     private GuiSlider sliderTilt;
@@ -134,7 +134,8 @@ public class GuiPhotoMode extends GuiScreen
         buttonRotateLeft = new GuiButton(0, width / 2 - 59 - 2 - 20, height - 20, 20, 20, "<");
         buttonRotateRight = new GuiButton(1, width / 2 + 59 + 2 + 1, height - 20, 20, 20, ">");
         buttonTakeScreenshot = new GuiButton(4, width / 2 - 59, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
-        buttonOpenScreenshotFolder = new GuiListenerTextureButton(30, "/assets/minecraft/textures/gui/gui.png", buttonTakeScreenshot.getWidth() + buttonTakeScreenshot.getX() + 1, buttonTakeScreenshot.getY(), 100, 106 - 20, 20, 20);
+        buttonOpenScreenshotFolder = (GuiListenerButton) new GuiListenerButton(30, buttonTakeScreenshot.getWidth() + buttonTakeScreenshot.getX() + 1, buttonTakeScreenshot.getY(), 20, 20, "")
+            .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder");
         buttonOpenScreenshotFolder.setActionListener(() -> {
             File f = new File(mc.getMinecraftDir(), "screenshots");
             f.mkdirs();
@@ -322,15 +323,15 @@ public class GuiPhotoMode extends GuiScreen
     public void drawScreen(int mouseX, int mouseY, float partialTick)
     {
         GL11.glViewport(0, 0, mc.resolution.width, mc.resolution.height);
-        GL11.glMatrixMode(5889 /*GL_PROJECTION*/);
+        GL11.glMatrixMode(GL11.GL_PROJECTION);
         GL11.glLoadIdentity();
-        GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
+        GL11.glMatrixMode(GL11.GL_MODELVIEW);
         GL11.glLoadIdentity();
         GL11.glClear(256);
-        GL11.glMatrixMode(5889 /*GL_PROJECTION*/);
+        GL11.glMatrixMode(GL11.GL_PROJECTION);
         GL11.glLoadIdentity();
         GL11.glOrtho(0.0D, mc.resolution.scaledWidth, mc.resolution.scaledHeight, 0.0D, 1000D, 3000D);
-        GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
+        GL11.glMatrixMode(GL11.GL_MODELVIEW);
         GL11.glLoadIdentity();
         GL11.glTranslatef(0.0F, 0.0F, -2000F);
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiPickMonster.java b/src/main/java/net/minecraft/client/gui/GuiPickMonster.java
index 6876101cf..807b4c278 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPickMonster.java
+++ b/src/main/java/net/minecraft/client/gui/GuiPickMonster.java
@@ -2,13 +2,12 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.gui.popup.GuiPopup;
 import net.minecraft.client.gui.popup.PopupBuilder;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.core.net.packet.Packet132SetMobSpawner;
-import net.minecraft.core.world.World;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.core.net.packet.SetMobSpawnerPacket;
 
 import java.lang.reflect.Modifier;
 import java.util.ArrayList;
@@ -35,8 +34,8 @@ public class GuiPickMonster
     public void init() {
         List<String> monsters = new ArrayList<>();
         for (Class<? extends Entity> clazz : EntityDispatcher.classToKeyMap.keySet()) {
-            if (clazz == EntityFireflyCluster.class) continue;
-            if (EntityLiving.class.isAssignableFrom(clazz) && !Modifier.isAbstract(clazz.getModifiers())) {
+            if (clazz == FireflyClusterMob.class) continue;
+            if (Mob.class.isAssignableFrom(clazz) && !Modifier.isAbstract(clazz.getModifiers())) {
                 monsters.add(EntityDispatcher.classToKeyMap.get(clazz));
             }
         }
@@ -62,13 +61,13 @@ public class GuiPickMonster
                 if (statusCode == 1) {
                     mobId = monsters.get((Integer) results.get("list"));
                     if (!mc.theWorld.isClientSide) {
-                        TileEntityMobSpawner spawner = (TileEntityMobSpawner) mc.theWorld.getBlockTileEntity(x, y, z);
+                        MobSpawnerBlockEntity spawner = (MobSpawnerBlockEntity) mc.theWorld.getBlockEntity(x, y, z);
                         if (spawner == null) {
                             return;
                         }
                         spawner.setMobId(mobId);
                     } else {
-                        mc.getSendQueue().addToSendQueue(new Packet132SetMobSpawner(x, y, z, mobId));
+                        mc.getSendQueue().addToSendQueue(new SetMobSpawnerPacket(x, y, z, mobId));
                     }
                 }
                 shouldClose = true;
diff --git a/src/main/java/net/minecraft/client/gui/GuiRenderItem.java b/src/main/java/net/minecraft/client/gui/GuiRenderItem.java
index 8d347dbe2..9be76dd78 100644
--- a/src/main/java/net/minecraft/client/gui/GuiRenderItem.java
+++ b/src/main/java/net/minecraft/client/gui/GuiRenderItem.java
@@ -6,15 +6,15 @@ import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
@@ -41,8 +41,8 @@ public class GuiRenderItem extends Gui
         if (slot != null)
         {
             discovered = slot.getIsDiscovered(mc.thePlayer);
-            if (slot.getBackgroundIconId() != null) {
-                final IconCoordinate iconIndex = TextureRegistry.getTexture(slot.getBackgroundIconId());
+            if (slot.getItemIcon() != null) {
+                final IconCoordinate iconIndex = TextureRegistry.getTexture(slot.getItemIcon());
                 if (itemStack == null)
                 {
                     GL11.glDisable(GL11.GL_LIGHTING);
@@ -61,12 +61,12 @@ public class GuiRenderItem extends Gui
                 BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
                 ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
                 itemModel.renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, discovered ? 1.0f : 0.0f, 1.0f);
-                if(slot instanceof SlotGuidebook){
-                    if(((SlotGuidebook) slot).recipe instanceof RecipeEntryTrommel && ((SlotGuidebook) slot).item != null && ((SlotGuidebook) slot).isOutput){
-                        WeightedRandomBag<WeightedRandomLootObject> loot = ((RecipeEntryTrommel)((SlotGuidebook) slot).recipe).getOutput();
-                        int index = slot.id;
-                        if(((SlotGuidebook) slot).recipeAmount > 8){
-                            index = slot.id + (9 * ((SlotGuidebook) slot).recipeIndex);
+                if(slot instanceof GuidebookSlot){
+                    if(((GuidebookSlot) slot).recipe instanceof RecipeEntryTrommel && ((GuidebookSlot) slot).item != null && ((GuidebookSlot) slot).isOutput){
+                        WeightedRandomBag<WeightedRandomLootObject> loot = ((RecipeEntryTrommel)((GuidebookSlot) slot).recipe).getOutput();
+                        int index = slot.index;
+                        if(((GuidebookSlot) slot).recipeAmount > 8){
+                            index = slot.index + (9 * ((GuidebookSlot) slot).recipeIndex);
                         }
                         WeightedRandomLootObject lootObject = loot.getEntries().get(index);
                         String s;
diff --git a/src/main/java/net/minecraft/client/gui/GuiScreen.java b/src/main/java/net/minecraft/client/gui/GuiScreen.java
index cc38d5e21..5b4372aef 100644
--- a/src/main/java/net/minecraft/client/gui/GuiScreen.java
+++ b/src/main/java/net/minecraft/client/gui/GuiScreen.java
@@ -11,7 +11,6 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.input.InputType;
 
-import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -182,10 +181,10 @@ public class GuiScreen extends Gui
 
     public void drawBackground()
     {
-        GL11.glDisable(2896 /*GL_LIGHTING*/);
-        GL11.glDisable(2912 /*GL_FOG*/);
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_FOG);
         Tessellator tessellator = Tessellator.instance;
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float f = 32F;
         tessellator.startDrawingQuads();
@@ -201,8 +200,7 @@ public class GuiScreen extends Gui
     	glDisable(GL_DEPTH_TEST);
     	glEnable(GL_BLEND);
     	glColor3d(1.0, 1.0, 1.0);
-    	glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
-    	drawTexturedModalRect(mc.controllerInput.cursorX - 8, mc.controllerInput.cursorY - 8, 224, 0, 16, 16, 32, 32);
+        drawGuiTexture(mc.renderEngine, (int) (mc.controllerInput.cursorX - 8), (int) (mc.controllerInput.cursorY - 8), 16, 16, "/assets/minecraft/textures/gui/controller/cursor.png");
     	glDisable(GL_BLEND);
     }
     public void controllerInput(ControllerInput controller){
